Attribute VB_Name = "Rijndael"
Option Explicit

Public Potenz(254) As Long, Logarithmus(255) As Long
Public Substitution(255) As Long, InvSubstitution(255) As Long
Public key(3, 43) As Byte, ikey(3, 43) As Byte, rc(30) As Byte
Public t(255, 7) As Long, t2(255, 7) As Long

Public asm_reb() As Long, asm_deb() As Long

Private Declare Sub RtlMoveMemory Lib "kernel32" (Destination As Any, Source As Any, ByVal Length As Long)

Public Function Rijndael_EncryptBlock(ByRef p1 As Byte, ByRef p2 As Byte, ByRef p3 As Long, ByVal p4 As Long) As Long
    API_CallWindowProc VarPtr(asm_reb(0)), VarPtr(p1), VarPtr(p2), VarPtr(p3), p4
End Function

Public Function Rijndael_DecryptBlock(ByRef p1 As Byte, ByRef p2 As Byte, ByRef p3 As Long, ByVal p4 As Long) As Long
    API_CallWindowProc VarPtr(asm_deb(0)), VarPtr(p1), VarPtr(p2), VarPtr(p3), p4
End Function

Public Sub InvMixColumns(block() As Byte, Optional start As Long = 0, Optional ende As Long = -1)
  Dim i As Long, j As Long, tmp(3) As Long
  
    If ende = -1 Then ende = UBound(block, 2)
    For j = start To ende
      For i = 0 To 3
        tmp(i) = mul(block(i, j), &HE&) Xor mul(block((i + 1) Mod 4, j), &HB&) Xor _
                 mul(block((i + 2) Mod 4, j), &HD&) Xor mul(block((i + 3) Mod 4, j), &H9&)
      Next i
      For i = 0 To 3
        block(i, j) = tmp(i)
      Next i
    Next j
End Sub

