VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cCpuClk"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long

Private MemoryHandle As Long, OldCode As Long, NewCode As Long, Myself As Long

'Liest per Assemblerbefehl RDTSC den Timestampcounter
Public Sub CpuClk(Cycles As Currency)
End Sub

Private Sub Class_Initialize()
    MemoryHandle = GlobalAlloc(0, 16)
    NewCode = GlobalLock(MemoryHandle)
    CopyMemory Myself, ByVal ObjPtr(Me), 4
    CopyMemory ByVal NewCode + &H0, &H4C8B310F, 4
    CopyMemory ByVal NewCode + &H4, &H1890824, 4
    CopyMemory ByVal NewCode + &H8, &H33045189, 4
    CopyMemory ByVal NewCode + &HC, &H8C2C0, 4
    CopyMemory OldCode, ByVal Myself + &H1C, 4
    CopyMemory ByVal Myself + &H1C, NewCode, 4
    GlobalUnlock MemoryHandle
End Sub

Private Sub Class_Terminate()
    CopyMemory ByVal Myself + &H1C, OldCode, 4
    GlobalFree MemoryHandle
End Sub
