Attribute VB_Name = "Hilfsfunktionen"
Option Explicit

Public Declare Function API_CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Function shr(x As Long, n As Long) As Long
  Static asm(4) As Long
  
    If asm(0) = 0 Then
      asm(0) = &H33EC8B55: asm(1) = &H8BC88BC0
      asm(2) = &H4D8A0845: asm(3) = &H5DE8D30C
      asm(4) = &H10C2
    End If
    
    shr = API_CallWindowProc(VarPtr(asm(0)), x, n, 0&, 0&)
End Function

Public Function shl(x As Long, n As Long) As Long
  Static asm(4) As Long
  
    If asm(0) = 0 Then
      asm(0) = &H33EC8B55: asm(1) = &H8BC88BC0
      asm(2) = &H4D8A0845: asm(3) = &H5DE0D30C
      asm(4) = &H10C2
    End If
    
    shl = API_CallWindowProc(VarPtr(asm(0)), x, n, 0&, 0&)
End Function

Public Function Min(x As Long, y As Long) As Long
    If x < y Then Min = x Else Min = y
End Function

Public Sub PrintBlock(block() As Byte)
  Dim i As Long, j As Long, tmp As String
        
    For j = 0 To UBound(block, 1)
      For i = 0 To UBound(block, 2)
        tmp = Hex(block(j, i))
        If Len(tmp) < 2 Then Log_NCR "0"
        Log_NCR tmp & " "
      Next i
      Log_NCR vbCrLf
    Next j
    Log_NCR vbCrLf
End Sub

Public Sub StringToBlock(inp As String, block() As Byte, blockbits As Long)
  Dim i As Long, bInp() As Byte
  
    ReDim block(blockbits / 32 - 1, 3)
    
    bInp = StrConv(inp, vbFromUnicode)
    
    For i = 0 To UBound(block, 1)
      block(i, 0) = bInp(i * 4)
      block(i, 1) = bInp(i * 4 + 1)
      block(i, 2) = bInp(i * 4 + 2)
      block(i, 3) = bInp(i * 4 + 3)
    Next i
End Sub

Public Sub Log(x As String)
    TestForm.Text1.Text = TestForm.Text1.Text & x & vbCrLf
    TestForm.Text1.SelStart = Len(TestForm.Text1.Text)
    
    Debug.Print x
    
    DoEvents
End Sub

Public Sub Log_NCR(x As String)
    TestForm.Text1.Text = TestForm.Text1.Text & x
    TestForm.Text1.SelStart = Len(TestForm.Text1.Text)
    
    Debug.Print x;
    
    DoEvents
End Sub
